
// DemoApplicationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoApplication.h"
#include "DemoApplicationDlg.h"
#include "afxdialogex.h"
#include "BubbleSeries.h"
#include "Series.h"
#include "Axes.h"
#include "axis.h"
#include <fstream> 
#include<string>
#include "axislabels.h"
#include "TeeChartDefines.h"
#include "colorgridSeries.h"
#include "mapseries.h"
#include "mapPolygonList.h"
#include "mapPolygon.h"
#include "mapmarks.h"
#include "Brush.h"
#include "marks.h"
#include "point3dseries.h"
#include "pen.h"
#include "ValueList.h"
#include "pointer.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CDemoApplicationDlg dialog



CDemoApplicationDlg::CDemoApplicationDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDemoApplicationDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	iEditPolyVerticesSer = -1;
	iEditPolySegment = -1;
	Polytolerance = 50;
	ISAddPolygonPoint = false;
	ISDeletePoint = false;
}

void CDemoApplicationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TCHART1, m_Chart);
}

BEGIN_MESSAGE_MAP(CDemoApplicationDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PLOT_POLYGON_BUTTON, &CDemoApplicationDlg::OnBnClickedPlotPolygonButton)
	ON_BN_CLICKED(IDC_EDIT_POLY_BUTTON, &CDemoApplicationDlg::OnBnClickedEditPolyButton)
	ON_BN_CLICKED(IDC_END_EDIT_BUTTON, &CDemoApplicationDlg::OnBnClickedEndEditButton)
END_MESSAGE_MAP()


// CDemoApplicationDlg message handlers

BOOL CDemoApplicationDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	PlotChart();


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoApplicationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoApplicationDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoApplicationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
//bubble plot 
 void CDemoApplicationDlg::PlotChart()
 {
 	//m_Chart.clear();
	
	 m_Chart.AddSeries(scBubble);
	
 	std::vector<double> xPoints = { 829, 487, 432, 781, 358, 730, 402, 721 };
 	std::vector<double> yPoints = { 122.667, 149.667, 109.667, 137.667, 114.667, 122.667, 137.667, 157.667 };

 	CString sBN = "S";
 	
 	for(int i = 0; i < 8 ; i++)
 		m_Chart.Series(0).GetAsBubble().AddBubble(xPoints.at(i), yPoints.at(i), 4, sBN, RGB(0, 0, 255));
 
 	m_Chart.Repaint();

	
 }
 
void CDemoApplicationDlg::OnDblClickTchart1()
{
	// TODO: Add your message handler code here
	m_Chart.ShowEditor(-1);
}
//polygon plotting 
void CDemoApplicationDlg::PlotPolygon()
{
 	m_Chart.Series(PolySer).Clear();
 	m_Chart.Series(PolySer).SetActive(1);
 	m_Chart.Series(PolySer).GetAsMap().SetUsePalette(1);
 	m_Chart.Series(PolySer).GetMarks().SetVisible(1);
 	m_Chart.Series(PolySer).GetAsMap().GetBrush().SetStyle(1);

	int counter = 0;

	for (int i = 0; i < numPolygon; i++)
	{
		m_Chart.Series(PolySer).GetAsMap().GetShapes().Add();
		CMapPolygon map = m_Chart.Series(PolySer).GetAsMap().GetShapes().GetPolygon(i);
		m_Chart.Series(PolySer).GetAsMap().GetMapMarks().SetAutoSize(false);
		m_Chart.Series(PolySer).GetAsMap().GetMapMarks().SetTextStyle(2);

		int jj = -1;
		try
		{
			
			jj = Points.at(i);
		}
		catch (...)
		{
			//Trace("Error - Getting points in Plot()\n");
		}
		for (int j = 0; j < jj; j++)
		{
			double fxx = 0.0, fyy = 0.0;
			try
			{


				fxx = xx.at(counter);
				fyy = yy.at(counter);
			}
			catch (...)
			{
				//Trace("Error - Getting x y points in Plot()\n");
			}
			map.AddXY(fxx, fyy);
			counter++;
		}

		map.SetClosed(1);
		map.SetTransparency(10);
		CString stt;
		try{
			stt = sPolyNames.at(i).c_str();
		}
		catch (...)
		{
			//Trace("Error - Getting polygon names in Plot()\n");
		}
		m_Chart.Series(PolySer).GetAsMap().GetShapes().GetPolygon(i).SetText(stt);
		m_Chart.Series(PolySer).SetHorizontalAxis(aBottomAxis);
		m_Chart.Series(PolySer).SetVerticalAxis(aLeftAxis);
		m_Chart.Series(PolySer).GetMarks().SetVisible(1);

		m_Chart.Repaint();
	}

	
}
//polygon plotting 
void CDemoApplicationDlg::EditPolygon()
{
	if (iEditPolyVerticesSer == -1)
	{
		m_Chart.AddSeries(scPoint3D);
		iEditPolyVerticesSer = m_Chart.GetSeriesCount() - 1;
		m_Chart.Series(iEditPolyVerticesSer).SetActive(1);
		m_Chart.Series(iEditPolyVerticesSer).GetAsPoint3D().GetLinePen().SetVisible(FALSE);
		
	}

	if (iEditPolySegment == -1)
	{
		m_Chart.AddSeries(scMap);
		iEditPolySegment = m_Chart.GetSeriesCount() - 1;
	}

	ISAddPolygonPoint = true;

	//highlight edit polygon 
	if (iEditPolyVerticesSer != -1)
	{
		xEdit.clear();
		yEdit.clear();
		xEdit = xx;
		yEdit = yy;

		int  points = xEdit.size();
		m_Chart.Series(iEditPolyVerticesSer).Clear();

		for (int i = 0; i < points; i++)
		{
			m_Chart.Series(iEditPolyVerticesSer).AddXY(xEdit.at(i), yEdit.at(i), "", clTeeColor);
		}
		m_Chart.Series(iEditPolyVerticesSer).GetXValues().SetOrder(loNone);
		m_Chart.Series(iEditPolyVerticesSer).GetYValues().SetOrder(loNone);
		m_Chart.Series(iEditPolyVerticesSer).GetAsPoint3D().GetPointer().SetStyle(psRectangle);
		m_Chart.Series(iEditPolyVerticesSer).SetColor(RGB(128, 0, 0));
	}
	xEdit.clear();
	yEdit.clear();

}

BEGIN_EVENTSINK_MAP(CDemoApplicationDlg, CDialogEx)
	ON_EVENT(CDemoApplicationDlg, IDC_TCHART1, 8, CDemoApplicationDlg::OnDblClickTchart1, VTS_NONE)
	ON_EVENT(CDemoApplicationDlg, IDC_TCHART1, 223, CDemoApplicationDlg::OnDragPointToolDragPointTchart1, VTS_I4)
	ON_EVENT(CDemoApplicationDlg, IDC_TCHART1, 20, CDemoApplicationDlg::OnMouseMoveTchart1, VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CDemoApplicationDlg, IDC_TCHART1, 21, CDemoApplicationDlg::OnMouseUpTchart1, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CDemoApplicationDlg, IDC_TCHART1, 19, CDemoApplicationDlg::OnMouseDownTchart1, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
END_EVENTSINK_MAP()




void CDemoApplicationDlg::OnBnClickedPlotPolygonButton()
{
	 PolySer = 1;
	xx.clear();
	yy.clear();
	numPolygon = 1;
	Points.clear();
	Points.push_back(6);
	std::vector<double> xPolyPoint = { 550.5, 575.5, 600.5, 650.5, 700.5, 400.5 };

	std::vector<double> yPolyPoint = { 120.5, 125.5, 130.5, 135.5, 140.5, 120.5 };

	xx = xPolyPoint;
	yy = yPolyPoint;

	sPolyNames.push_back("Polygon1");
	
	m_Chart.AddSeries(scMap);
	PlotPolygon();
}


void CDemoApplicationDlg::OnBnClickedEditPolyButton()
{
	EditPolygon();
}

//remove edit series 
void CDemoApplicationDlg::OnBnClickedEndEditButton()
{
	int count = m_Chart.GetSeriesCount();
	if (iEditPolyVerticesSer != -1)
	{
		m_Chart.Series(iEditPolyVerticesSer).Clear();
		m_Chart.RemoveSeries(iEditPolyVerticesSer);
		iEditPolyVerticesSer = -1;
	}

	count = m_Chart.GetSeriesCount();
	if (iEditPolySegment != -1)
	{
		m_Chart.Series(iEditPolySegment).SetActive(FALSE);
		m_Chart.RemoveSeries(iEditPolySegment);
		iEditPolySegment = -1;
	}


	m_Chart.Repaint();

}


void CDemoApplicationDlg::OnDragPointToolDragPointTchart1(long Index)
{

}

bool CDemoApplicationDlg::IsPolygonSegmentSelected(long X, long Y)
{
	int polyID = 0;
	int iSelTree;
	
	if (polyID >= 0)
	{
		double tempx1, tempy1;
		double tempx2, tempy2;
		double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
		double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);
		std::vector<double> tempXX;
		std::vector<double>tempYY;
		std::vector<int> tempPoints;
		int pointsBefore = 0;
		int points;
	//polygon is selected
		{
			tempXX=xx;
			tempYY=yy;
			tempPoints=Points;
			points = Points.at(polyID);
			for (int i = 0; i < polyID; i++)
			{
				pointsBefore += Points.at(i);
			}
		}

		double minsumDistance = 0;
		for (int i = 0; i < points; i++)
		{
			tempx1 = tempXX.at(pointsBefore + i);
			tempy1 = tempYY.at(pointsBefore + i);
			if (i + 1 == points)
			{
				tempx2 = tempXX.at(pointsBefore + 0);
				tempy2 = tempYY.at(pointsBefore + 0);
			}
			else
			{
				tempx2 = tempXX.at(pointsBefore + i + 1);
				tempy2 = tempYY.at(pointsBefore + i + 1);
			}


			double  calsumDistance = sqrt((tempx1 - px)*(tempx1 - px) + (tempy1 - py)*(tempy1 - py)) + sqrt((tempx2 - px)*(tempx2 - px) + (tempy2 - py)*(tempy2 - py));
			double pointDistance = sqrt((tempx1 - tempx2)*(tempx1 - tempx2) + (tempy1 - tempy2)*(tempy1 - tempy2));
			double diff = abs((calsumDistance - pointDistance));
			if (diff <= 2)
			{
				return true;//if point lies close to line segment return true
			}
		}
		return false;
	}
	m_Chart.StopMouse();
}
void CDemoApplicationDlg::OnMouseMoveTchart1(long Shift, long X, long Y)
{
	//mouse cursor change on editing 
	if (ISAddPolygonPoint == true)
	{
		if (IsPolygonSegmentSelected(X, Y) || IsPolygonVertexSelected(X, Y))
			m_Chart.SetCursor(-21);
		else
			m_Chart.SetCursor(0);
	}


	//draw dash polygon 
	if (ISAddPolygonPoint == true && IsSegmentFound == true)
	{
		m_Chart.Series(iEditPolySegment).Clear();
		m_Chart.Series(iEditPolySegment).GetPen().SetStyle(psDash);
		m_Chart.Series(iEditPolySegment).GetPen().SetColor(0x00ff0000);
		m_Chart.Series(iEditPolySegment).GetAsMap().GetPen().SetWidth(2);
		m_Chart.Series(iEditPolySegment).SetActive(TRUE);
		double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
		double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);
		m_Chart.Series(iEditPolySegment).GetAsMap().GetShapes().Add();
		CMapPolygon map = m_Chart.Series(iEditPolySegment).GetAsMap().GetShapes().GetPolygon(0);
		double tempadjX1, tempadjY1, tempadjX2, tempadjY2;
		tempadjX1 = adjX1;
		tempadjY1 = adjY1;
		tempadjX2 = adjX2;
		tempadjY2 = adjY2;

		map.AddXY(tempadjX1, tempadjY1);
		map.AddXY(px, py);
		map.AddXY(tempadjX2, tempadjY2);
		map.SetClosed(0);
		map.SetTransparency(0);
	}
}


void CDemoApplicationDlg::OnMouseUpTchart1(long Button, long Shift, long X, long Y)
{
	if (Button == 1)
	{
		if (IsVertexFound)
		{
			IsVertexFound = false;
			IsSegmentFound = true;
			bool IsPointDeleted = true;
			int polyID = 0;;
			

			if (polyID >= 0)
			{
				int px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
				int py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);

				{
					IsPointDeleted = DeletePointFromPolygon(polyID, pickPoint_x, pickPoint_y);       // remove pick point 
				}
				if (!IsPointDeleted)
				{
					m_Chart.Series(iEditPolySegment).Clear();

					PlotPolygon();

					
					HighlightPolygonVertices(polyID);
					m_Chart.Repaint();
					IsSegmentFound = false;

					return;
				}
			}
		}

		if (IsSegmentFound)
		{
			double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
			double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);
			int polyID = 0;
			AddPointToPolygon(polyID, px, py);     // add new point in polygon data structure 

			m_Chart.Series(iEditPolySegment).Clear();
			

			PlotPolygon();
			HighlightPolygonVertices(polyID);
			m_Chart.Repaint();
			IsSegmentFound = false;


		}
	}

	if (IsSegmentFound)
	{
		int polyID = -1;
		polyID = 0;
		if (polyID >= 0)
		{

			double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
			double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);
			AddPointToPolygon(polyID, px, py);
			m_Chart.Series(iEditPolySegment).Clear();
	
			PlotPolygon();


			HighlightPolygonVertices(polyID);
			m_Chart.Repaint();
		}

		
	}

	IsSegmentFound = false;



UpdateData(FALSE);
}
 bool CDemoApplicationDlg::DeletePointFromPolygon(int polyID, double x, double y)
 {
 	int iSelTree;
 	CString polyName;
 
 	std::vector<double> tempXX;
 	std::vector< double>tempYY;
 	std::vector<int> tempPoints;
 	int pointsBefore = 0;
 	int points;

 	{
 		tempXX = xx;
 		tempYY = yy;
 		tempPoints = Points;
 		points = Points.at(polyID);
 
 		for (int i = 0; i < polyID; i++)
 		{
 			pointsBefore += Points.at(i);
 		}
 	}
 
 
 	if (points == 3 && ISDeletePoint == true /*&& polytype != POLYTYPE_FAULT*/)//if deletion is done of the point from right click
 	{
 		AfxMessageBox("Atleast three points are required for polygon.");
 		ISDeletePoint = false;
 		return false;
 	}
 
 
 
 	ISDeletePoint = false;
 	bool PointFound = false;
 	int i = pointsBefore;
 
 	int minDx, minDy, nindex, minDist = -1;
 	minDx = x;
 	minDy = y;
 	nindex = 0;
 
 	for (; i < tempXX.size(); i++)
 	{
 		int dx = abs(tempXX.at(i) - x);
 		int	dy = abs(tempYY.at(i) - y);
 		if (dx <= Polytolerance && dy <= Polytolerance)
 		{
 			int currDist = dx + dy;
 			if (minDist < 0 || currDist < minDist)
 			{
 				minDx = dx;
 				minDy = dy;
 				nindex = i;
 				minDist = currDist;
 			}
 
 			PointFound = true;
 			
 		}
 	}
 	if (PointFound == true)
 	{
 		tempPoints.at(polyID) =  points - 1;//update points
 		tempXX.erase(tempXX.begin()+nindex);
 		tempYY.erase(tempYY.begin()+nindex);
 	}
 
 
 	
 	{
 		xx.clear();
 		yy.clear();
 		Points.clear();
 		xx= tempXX;
 		yy= tempYY;
 		Points = tempPoints;
 	}
 
 	return true;
 }

void CDemoApplicationDlg::HighlightPolygonVertices(int iDNo)
{
	std::vector<double> xEdit;
	std::vector< double>yEdit;
	int points;

		points = Points.at(iDNo);


	int pointsBefore = 0;
	for (int i = 0; i < iDNo; i++)
	{
		
			pointsBefore += Points.at(i);

	}
	for (int i = 0; i < points; i++)
	{
		
		{
			xEdit.push_back(xx.at(pointsBefore + i));
			yEdit.push_back(yy.at(pointsBefore + i));
		}

	}
	if (iEditPolyVerticesSer != -1)
	{
		m_Chart.Series(iEditPolyVerticesSer).Clear();

		for (int i = 0; i < points; i++)
		{
			m_Chart.Series(iEditPolyVerticesSer).AddXY(xEdit.at(i), yEdit.at(i), "", clTeeColor);
		}
		m_Chart.Series(iEditPolyVerticesSer).GetXValues().SetOrder(loNone);
		m_Chart.Series(iEditPolyVerticesSer).GetYValues().SetOrder(loNone);
		m_Chart.Series(iEditPolyVerticesSer).GetAsPoint3D().GetPointer().SetStyle(psRectangle);
		m_Chart.Series(iEditPolyVerticesSer).SetColor(RGB(128, 0, 0));
	}
	xEdit.clear();
	yEdit.clear();
}

void CDemoApplicationDlg::AddPointToPolygon(int polyID, double x, double y)
{
	
	int iSelTree;
	CString polyName;


	std::vector<double> tempXX;
	std::vector<double> tempYY;
	std::vector<int> tempPoints;

	int pointsBefore = 0;
	int points;
	
	{
		tempXX = xx;
		tempYY = yy;
		tempPoints= Points;
		points = Points.at(polyID);

		for (int i = 0; i < polyID; i++)
		{
			pointsBefore += Points.at(i);
		}
	}


	int i = pointsBefore;

	int minDx, minDy, minDist = -1;
	minDx = x;
	minDy = y;

	int tempxSz = tempXX.size();
	int tempYSz = tempYY.size();

	for (; i < tempXX.size(); i++)
	{
		int dx = abs(tempXX.at(i) - adjX1);
		int	dy = abs(tempYY.at(i) - adjY1);


		if (dx <= Polytolerance && dy <= Polytolerance)
		{
			

			int currDist = dx + dy;
			if (minDist < 0 || currDist < minDist)
			{
				minDx = dx;
				minDy = dy;
				minDist = currDist;
				addpointPos = i;

			}


		}
	}
	tempPoints.at(polyID)  = points + 1;//update points


	
		int pos = addpointPos + 1;
		tempXX.insert(tempXX.begin()+ pos, x);
		tempYY.insert(tempYY.begin() +pos,y);
	
	
		xx.clear();
		yy.clear();
		Points.clear();
		xx= tempXX ;
		yy= tempYY;
		Points= tempPoints;
	



}
//find nearest point 
void CDemoApplicationDlg::GetSegmentAdjacents(long X, long Y)
{
	int polyID = 0;


	if (polyID >= 0)
	{
		double tempx1, tempy1;
		double tempx2, tempy2;
		adjX1 = adjX2 = adjY1 = adjY2 = 0;
		double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
		double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);


		std::vector<double> tempXX;
		std::vector<double> tempYY;
		std::vector<int> tempPoints;

		int pointsBefore = 0;
		int points;
		//polygon is selected
		{
			tempXX= xx;
			tempYY= yy;
			tempPoints= Points;
			points = Points.at(polyID);

			for (int i = 0; i < polyID; i++)
			{
				pointsBefore += Points.at(i);
			}
		}

		double minsumDistance = 0;
		for (int i = 0; i < points; i++)
		{
			tempx1 = tempXX.at(pointsBefore + i);
			tempy1 = tempYY.at(pointsBefore + i);

			if (i + 1 == points)
			{
				tempx2 = tempXX.at(pointsBefore + 0);
				tempy2 = tempYY.at(pointsBefore + 0);
			}
			else
			{
				tempx2 = tempXX.at(pointsBefore + i + 1);
				tempy2 = tempYY.at(pointsBefore + i + 1);
			}
			double  calsumDistance = sqrt((tempx1 - px)*(tempx1 - px) + (tempy1 - py)*(tempy1 - py)) + sqrt((tempx2 - px)*(tempx2 - px) + (tempy2 - py)*(tempy2 - py));
			double pointDistance = sqrt((tempx1 - tempx2)*(tempx1 - tempx2) + (tempy1 - tempy2)*(tempy1 - tempy2));
			double diff = abs((calsumDistance - pointDistance));
			if (diff <= Polytolerance)
			{
				adjX1 = tempx1;
				adjY1 = tempy1;
				adjX2 = tempx2;
				adjY2 = tempy2;

			 IsSegmentFound = true;
				break;
			}
		}
		tempXX.clear();
		tempYY.clear();
		tempPoints.clear();
	}
	m_Chart.StopMouse();
}

void CDemoApplicationDlg::OnMouseDownTchart1(long Button, long Shift, long X, long Y)
{
	
	if (Button == 1)
	{
	if (ISAddPolygonPoint == true)
	{
		IsSegmentFound = false;
		GetSegmentAdjacents(X, Y);//this method updates adjX1,adjX2,adjY1,adjY2 ie,selected segment coordinates
		if (IsPolygonVertexSelected(X, Y))//update adjacent points if vertex is selected
		{

			pickPoint_x = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
			pickPoint_y = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);

			double x = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
			double y = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);

			int polyID = 0;
			


			std::vector<double> tempXX;
			std::vector<double>tempYY;
			std::vector<int> tempPoints;


			int pointsBefore = 0;
			int points;
		
			{
				tempXX = xx;
				tempYY = yy;
				tempPoints = Points;
				points = Points.at(polyID);

				for (int i = 0; i < polyID; i++)
				{
					pointsBefore += Points.at(i);
				}
			}
						
			int minDx, minDy, nindex, minDist = -1;
			minDx = x;
			minDy = y;
			nindex = 0;
			for (int i = 0; i < points; i++)
			{
				int dx = abs(x - tempXX.at(pointsBefore + i));
				int dy = abs(y - tempYY.at(pointsBefore + i));



				if (dx <= Polytolerance && dy <= Polytolerance)
				{
					int currDist = dx + dy;
					if (minDist < 0 || currDist < minDist)
					{
						minDx = dx;
						minDy = dy;
						nindex = i;
						minDist = currDist;
					}

					IsVertexFound = true;



				}
			}


			

			if (IsVertexFound)
			{

				if (nindex == 0)
				{
					
					{
						adjX1 = tempXX.at(pointsBefore + points - 1);
						adjY1 = tempYY.at(pointsBefore + points - 1);
					}


				}
				else
				{
					adjX1 = tempXX.at(pointsBefore + nindex - 1);
					adjY1 = tempYY.at(pointsBefore + nindex - 1);
				}

				if (nindex + 1 == points)
				{
					
					{
						adjX2 = tempXX.at(pointsBefore + 0);
						adjY2 = tempYY.at(pointsBefore + 0);
					}

				}
				else
				{
					adjX2 = tempXX.at(pointsBefore + nindex + 1);
					adjY2 = tempYY.at(pointsBefore + nindex + 1);
				}

			}
			
		}
		
	}
}
}
// if point lies close to vertex return true
bool CDemoApplicationDlg::IsPolygonVertexSelected(long X, long Y)
{
	int polyID = 0;
	
	if (polyID >= 0)
	{
		double tempx1, tempy1;
		double px = m_Chart.GetAxis().GetBottom().CalcPosPoint(X);
		double py = m_Chart.GetAxis().GetLeft().CalcPosPoint(Y);
		std::vector<double> tempXX;
		std::vector< double>tempYY;
		std::vector<int> tempPoints;
		int pointsBefore = 0;
		int points;
	//polygon is selected
		{
			tempXX = xx;
			tempYY = yy;
			tempPoints = Points;
			points = Points.at(polyID);
			for (int i = 0; i < polyID; i++)
			{
				pointsBefore += Points.at(i);
			}
		}

		double minsumDistance = 0;
		for (int i = 0; i < points; i++)
		{
			tempx1 = tempXX.at(pointsBefore + i);
			tempy1 = tempYY.at(pointsBefore + i);
			double  diff = sqrt((tempx1 - px)*(tempx1 - px) + (tempy1 - py)*(tempy1 - py));
			if (diff <= Polytolerance)
			{
				return true;//if point lies close to vertex return true
			}
		}
		return false;
	}
	m_Chart.StopMouse();
}
